#!/usr/bin/perl
#
# Spinner-Wiki - changes.pl
#        Copyright (C) 2000 Bruce Dodson (bdodson@esricanada.com)
#
# Derived from DolphinWiki
#        Copyright (C) 1998 Object Arts Ltd (info@object-arts.com)
#
# DolphinWiki derived from JOS WikiClone.
#        Copyright (C) 1998 Markus Peter - SPiN GmbH (warpi@spin.de)
#
# and based on parts of Ward Cunninghams original Wiki.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

use CGI;
use wiki;


$query= new CGI;

main();

sub main {
    print $query->header(-Pragma=>'no-cache',-Cache_control=>'no-cache');

    my ($topic, $scriptUrl, $baseUrl, $htmlUrl, $userName, $textDir) = wiki::init( $query);

    my $output = '';
  
    my @htmStat = stat("$textDir/.changes.htm");
    if (@htmStat) {
        my @logStat = stat("$textDir/.changes");
        if (@logStat && ($htmStat[10] >= $logStat[10])) {
            my @tmpStat = wiki::statTemplate("changes");
            if (@tmpStat && ($htmStat[10] >= $tmpStat[10])) {
                # use the cache, Luke
                $output = wiki::readFile("$textDir/.changes.htm");
            }
        }
    }

    if ($output eq '') {
        $text = wiki::handleCommonTags(wiki::readTemplate("changes"));
        $changes= wiki::readFile("$textDir/.changes");
   
        my %exclude;



        $text =~ s/\$SCRIPTURL\$/$scriptUrl/go;
        $text =~ s/\$BASEURL\$/$baseUrl/go;
        $text =~ s/\$USER\$/$userName/go;
        $text =~ s/\$\$/\$/go;

        my ($before1, $text1, $after1) = split(/\$REPEATDATE\$/, $text);
        my ($before2, $text2, $after2) = split(/\$REPEATITEM\$/, $text1);

        $output = $before1;
  
        my $currentDate;
        foreach( reverse split( /\r?\n/, $changes)) {

            @lineEntry = split(/\t/);

            if( !defined( %exclude) || $exclude{$lineEntry[0]} ne "1") {
                my ($date, $time) = wiki::getDateTimeText($lineEntry[2]);
                my ($item, $author) = @lineEntry;
                if ($author =~ /^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/) {
                    $author = '&lt;anonymous&gt;';
                }
	

                $lineTemplate = $text;

                if ($currentDate ne $date) {
                    $currentDate = $date;
                    $output .= $after2;
                    $sectionText = $before2;
                    $sectionText =~ s/\$DATE\$/$currentDate/go;
                    $output .= $sectionText;
                }

                $lineText = $text2;
                $lineText =~ s/\$ITEM\$/$item/go;
                $lineText =~ s/\$AUTHOR\$/$author/go;
                $lineText =~ s/\$TIME\$/$time/go;
                $lineText =~ s/\$\$/\$/go;
                $output .= $lineText;
                $exclude{$lineEntry[0]}="1";
            }
        }
        $output .= $after1;

        wiki::saveFile("$textDir/.changes.htm", $output);

    }

    print $output;
    exit 0;
}
